/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Abstrakt.ADL;

import java.io.Serializable;

/**
 * Prvek ADS, který slouží, jako vnitřní struktura
 * @author Administrator
 * @param <objType> datová struktura, kterou bude Prvek ve svém těle uchovávat
 */
public class Prvek<objType> implements IPrvek<objType>, Serializable {
    private objType data;
    private IPrvek prev;
    private IPrvek next;

    /**
     * Bezparametrický konstruktor
     * Nastaví všechny prvky na null
     */
    public Prvek() {
        this.prev = null;
        this.next = null;
        this.data = null;
    }

    /**
      * Konstruktor s možností zadat jen obsah datové části
     * @param data datová část prvku
     */
    public Prvek(objType data) {
        this();
        this.data = data;
    }

    /**
     * Parametrický konstruktor s udáním předchozího i následujícího prvku
     * a datové části struktury
     * @param prev předchozí prvek v ADL
     * @param next následující prvek v ADL
     * @param data datová část prvku
     */
    public Prvek(Prvek prev, Prvek next, objType data) {
        this.prev = prev;
        this.next = next;
        this.data = data;
    }

    /**
     * @return the prev
     */
    public IPrvek getPrev() {
        return prev;
    }

    /**
     * @param prev the prev to set
     */
    public void setPrev(Prvek prev) {
        this.prev = prev;
    }

    /**
     * @return the next
     */
    public IPrvek getNext() {
        return next;
    }

    /**
     * @param next the next to set
     */
    public void setNext(Prvek next) {
        this.next = next;
    }

    /**
     * @return the data
     */
    public objType getData() {
        return data;
    }

    /**
     * @param data the data to set
     */
    public void setData(objType data) {
        this.data = data;
    }

    /**
     * Je následující prvek prázdný? Nevyužito!
     * @return true = je prázdný
     */
//    public boolean isEmpty() {
//        return next.isEmpty();
//        /*
//         if(next.isEmpty()) {
//            return true;
//        }
//        return false;
//         */
//    }
}
