/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Abstrakt.AbstrStrom;

import Abstrakt.IIterator;

/**
 *
 * @author Administrator
 */
public interface IAbstrStrom<objType> {

    /**
     * Dej kořen vrátí datový kontejner kořene
     * @return datový kontejner
     */
    objType dejKoren();

    /**
     * Vrátí počet prvků, které obsahuje celý ABstrStrom
     * @return počet prvků AbstrStromu
     */
    int dejMohutnost();

    /**
     * Vrátí datový kontejner specifického syna
     * @param index číselné vyjádření prvku mezi syny
     * @return datový kontejner
     */
    objType dejSyna(int index);

    /**
     * Je prázdný AbstrStrom?
     * @return true = je prázdný, false = není prázdný
     */
    boolean jePrazdny();

    /**
     * Odebere list ze seznamu
     * TODO: dodělat ošetření, pokud je odebíraný prvek již poslední ve stromu (je kořenem)
     * @return  datový kontejner
     */
    objType odeberList(int index);

    /**
     * Odebere podstrom, který se nachází pod aktuálním ukazatelem
     * @return IAbstrStrom - celá nová struktura
     */
    IAbstrStrom<objType> odeberPodstrom();

    /**
     * Vloží kořen - zavolá funkci pro vkládání prvku, která si již obhospodaří,
     * jaký prvek je vkládaný, zda-li se jedná o kořen, či list
     * @param data datový kontejner
     */
    void vlozKoren(objType data);

    /**
     * Vloží list - zavolá funkci pro vkládání prvku, která si již obhospodaří,
     * jaký prvek je vkládaný, zda-li se jedná o kořen, či list
     * @param data datový kontejner
     */
    void vlozList(objType data);

    /**
     * Vytvoří novou instanci kořene a nastaví kořen na aktuální
     */
    void vytvor();

    /**
     *
     * @param typProhlidky true = do šířky, false = do hloubky
     * @return Iterátor
     */
    IIterator<objType> vytvorIterator(TypProhlidky typProhlidky);

    /**
     * Zpřístupní kořen, nastaví kořen na aktuální
     * @return datový kontejner
     */
    objType zpristupniKoren();

    /**
     * Mělo by být OK
     * @return  datový kontejner
     */
    objType zpristupniSyna(int index);

    /**
     * Zrušení celého seznamu
     */
    void zrus();

}
