/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Aplikace.OrganizacePodniku;

import Abstrakt.AbstrStrom.AbstrStrom;
import Abstrakt.AbstrStrom.IAbstrStrom;
import Abstrakt.AbstrStrom.TypProhlidky;
import Abstrakt.IIterator;
import java.io.IOException;
import javax.annotation.processing.FilerException;

/**
 *
 * @author Administrator
 */
public class OrganizacePodniku<T> {

    private IAbstrStrom<Object> iAbstrStrom = new AbstrStrom<Object>() {
    };

    public void pridejKoren(T data) {
        this.iAbstrStrom.vlozKoren(data);
    }

    public void zrus() {
        this.iAbstrStrom.zrus();
    }

    public void vypis() {
        IIterator<Object> iIterator = this.iAbstrStrom.vytvorIterator(TypProhlidky.DO_SIRKY);
        while (iIterator.hasNext()) {
            System.out.println(iIterator.next().toString());
        }
    }

    /**
     * Načtení dat ze souboru
     *
     * Využita metoda z předmětu IJAV (loňský rok)
     *
     * @param nazevSouboru celý název souboru ze kterého se budou načítat data
     */
    public void nactiZeSouboru(String nazevSouboru) {
        ISoubor iSoubor = new Soubor();

        try {
            this.iAbstrStrom = (IAbstrStrom<Object>) iSoubor.nacti(nazevSouboru);
        } catch (FilerException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Načtení dat ze souboru s názvem data.dta
     */
    public void nactiZeSouboru() {
        nactiZeSouboru("data.dta");
    }

    /**
     * Uložení dat do souboru
     *
     * Využita metoda z předmětu IJAV (loňský rok)
     *
     * @param nazevSouboru název souboru, do kterého se bude ukládat
     */
    public void ulozDoSouboru(String nazevSouboru) {
        ISoubor iSoubor = new Soubor();

        try {
            iSoubor.uloz(nazevSouboru, this.iAbstrStrom);
        } catch (FilerException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Uložení dat do souboru s názvem data.dta
     */
    public void ulozDoSouboru() {
        ulozDoSouboru("data.dta");
    }

    /**
     * Uložení dat do textového souboru
     *
     * @param nazevSouboru název souboru, do kterého se bude ukládat
     */
    public void ulozDoTxtSouboru(String nazevSouboru) {
        ISouborTxt iSouborTxt = new SouborTxt();
        try {
            iSouborTxt.uloz(nazevSouboru, false, this.iAbstrStrom);
        } catch (FilerException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void vloz(Object data) {
        this.iAbstrStrom.vlozList(data);
    }
}
