/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Aplikace.ProgOrganizacePodniku;

import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * Statická třída pro načítání z klávesnice.
 * Statické metody se volají pro třídu ne pro instanci třídy.
 * 
 * @author Administrator
 */
public class Nacitani {

    /**
     * Statický atribut.
     * Je potřeba ho označit slovem static, protože ho používáme ve statických třídách.
     */
    private static Scanner scan = new Scanner(System.in);

    /**
     * Statická metoda vracející načtený řádek z klávesnice.
     * @param text Text, který se zobrazí před poždadavkem pro zadání řádku.
     * @return řetězec, který byl načten z klávesnice
     */
    public static String NactiRadekStr(String text) {
        System.out.print(text);
        String s = scan.nextLine();
//        if (scan.hasNextLine()) {
//            scan.nextLine();
//        }
        return s;
    }

    /**
     * Statická metoda vracející načtený znak z klávesnice.
     * @param text Text, který se zobrazí před poždadavkem pro zadání řádku.
     * @return znak načtený z klávesnice
     */
    public static char NactiRadekChar(String text) {
        System.out.print(text);
        char c = scan.next().charAt(0);
        if (scan.hasNextLine()) {
            scan.nextLine();
        }
        return c;
    }

    /**
     * Načte vrátí načtenou číselnou hodnotu.
     * @param text Text, který se zobrazí před poždadavkem pro zadání řádku.
     * @return číslo načtené z klávesnice
     */
    public static int NactiInt(String text) throws InputMismatchException {
        int number = 0;

        do {
            try {
                System.out.print(text);
                number = scan.nextInt();
            } catch (InputMismatchException e) {
                System.out.println("Vstup musi byt celociselny!");
                scan.nextLine();
            }
        } while (number <= 0);
        return number;
    }
}
