/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package idats_2009_semestralka_b_MatejTrakal_A;

import Abstrakt.IIterator;
import Abstrakt.AbstrStrom.IAbstrStrom;
import Abstrakt.AbstrStrom.AbstrStrom;
import Abstrakt.AbstrStrom.TypProhlidky;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author kasi0004
 */
public class AbstrTreeTest {

    class TestClass {

        int a;
        char c;

        TestClass(int v) {
            a = v;
        }

        TestClass(char v) {
            c = v;
        }

        TestClass(int v1, char v2) {
            a = v1;
            c = v2;
        }

        @Override
        public String toString() {
            return " a/c = " + a + "/" + c;

        }
    }

    class AbstrTreeImpl {

        IAbstrStrom<TestClass> tree = new AbstrStrom<TestClass>() {
        };

        int dejMohutnost() {
            return tree.dejMohutnost();
        }

        boolean jePrazdny() {
            return tree.jePrazdny();
        }

        void vlozKoren(TestClass t) {
            tree.vlozList(t);
        }

        void vlozPotomka(TestClass t) {
            tree.vlozList(t);
        }

        IAbstrStrom<TestClass> vyjmiPodstrom() {
            return tree.odeberPodstrom();
        }

        TestClass vyjmiPotomka(int index) {
            return tree.odeberList(index);
        }

        TestClass dejKoren() {
            return tree.dejKoren();
        }

        TestClass dejPotomka(int index) {
            return tree.dejSyna(index);
        }

        TestClass zpristupniKoren() {
            return tree.zpristupniKoren();
        }

        TestClass zpristupniPotomka(int index) {
            return tree.zpristupniSyna(index);
        }

        void zrus() {
            tree.zrus();
        }

        IIterator<TestClass> dejIterator(TypProhlidky t) {
            return tree.vytvorIterator(t);
        }
    }

    /**
     * Test of zrus method, of class AbstrTree.
     */
    @Test
    public void testZrus() {
        System.out.println("zrus");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        instance.zrus();
        assertEquals(0, instance.dejMohutnost());
        TestClass t1 = new TestClass(1);
        instance.vlozKoren(t1);
        assertEquals(1, instance.dejMohutnost());
        instance.zrus();
        assertEquals(0, instance.dejMohutnost());

    }

    /**
     * Test of jePrazdny method, of class AbstrTree.
     */
    @Test
    public void testJePrazdny() {
        System.out.println("jePrazdny");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        assertEquals(true, instance.jePrazdny());
        TestClass t1 = new TestClass(1);
        TestClass t2 = new TestClass(2);
        TestClass t3 = new TestClass(2);

        instance.vlozKoren(t1);
        assertEquals(false, instance.jePrazdny());
        instance.zrus();
        assertEquals(true, instance.jePrazdny());

        instance.vlozKoren(t1);
        assertEquals(false, instance.jePrazdny());
        instance.vlozPotomka(t2);
        assertEquals(false, instance.jePrazdny());
        instance.vlozPotomka(t3);
        assertEquals(false, instance.jePrazdny());
        assertEquals(3, instance.dejMohutnost());
        instance.zrus();
        assertEquals(true, instance.jePrazdny());
        assertEquals(0, instance.dejMohutnost());

    }

    /**
     * Test of dejMohutnost method, of class AbstrTree.
     */
    @Test
    public void testDejMohutnost() {
        System.out.println("dejMohutnost");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        TestClass t1 = new TestClass(1);
        instance.vlozKoren(t1);

        for (int i = 1; i < 100; i++) {
            instance.vlozPotomka(new TestClass(i));
            assertEquals(i + 1, instance.dejMohutnost());
        }
        assertEquals(100, instance.dejMohutnost());
    }

    /**
     * Test of vlozKoren method, of class AbstrTree.
     */
    @Test
    public void testVlozKoren() {
        System.out.println("vlozKoren");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        TestClass t1 = new TestClass(1);
        instance.vlozKoren(t1);
        assertEquals(t1, instance.zpristupniKoren());
    }

    /**
     * Test of vlozPotomka method, of class AbstrTree.
     */
    @Test
    public void testVlozPotomka() {
        System.out.println("vlozPotomka");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        TestClass t1 = new TestClass(1);
        instance.vlozKoren(t1);
    }

    /**
     * Test of vyjmiPodstrom method, of class AbstrTree.
     */
    @Test
    public void testVyjmiPodstrom() {
        System.out.println("vyjmiPodstrom");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        AbstrTreeImpl expResult = null;
        AbstrTreeImpl result = (AbstrTreeImpl) instance.vyjmiPodstrom();
        assertEquals(expResult, result);
    }

    /**
     * Test of vyjmiPotomka method, of class AbstrTree.
     */
    @Test
    public void testVyjmiPotomka() {
        System.out.println("vyjmiPotomka");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        TestClass t1 = new TestClass(1);
        instance.vlozKoren(t1);
    }

    /**
     * Test of zpristupniKren method, of class AbstrTree.
     */
    @Test
    public void testZpristupniKoren() {
        System.out.println("zpristupniKoren");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        TestClass t1 = new TestClass(1);
        instance.vlozKoren(t1);
        TestClass result = instance.zpristupniKoren();
        assertEquals(t1, result);
    }

    /**
     * Test of zpristupniPotomka method, of class AbstrTree.
     */
    @Test
    public void testZpristupniPotomka() {
        System.out.println("zpristupniPotomka");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        TestClass t0 = new TestClass(0);
        TestClass t1 = new TestClass(1, 'b');
        TestClass t2 = new TestClass(2);
        TestClass t3 = new TestClass(3);
        instance.zpristupniPotomka(1);

        instance.vlozKoren(new TestClass(0, 'a'));

        instance.vlozPotomka(new TestClass(1, 'b'));
        assertEquals(1, instance.dejPotomka(1).a);
        instance.vlozPotomka(new TestClass(2, 'b'));
        assertEquals(2, instance.dejPotomka(2).a);
        instance.vlozPotomka(new TestClass(3, 'c'));
        assertEquals(3, instance.dejPotomka(3).a);
        assertEquals(1, instance.dejPotomka(1).a);
        assertEquals(2, instance.dejPotomka(2).a);
        assertEquals(3, instance.dejPotomka(3).a);
        assertEquals(4, instance.dejMohutnost());

        instance.zpristupniPotomka(1);
        instance.vlozPotomka(t3);
        assertEquals(t3, instance.dejPotomka(1));
        instance.vlozPotomka(t2);
        assertEquals(t2, instance.dejPotomka(2));
        instance.vlozPotomka(t1);
        assertEquals(t1, instance.dejPotomka(3));
        assertEquals(t2, instance.dejPotomka(2));
        assertEquals(t3, instance.dejPotomka(1));
        assertEquals(7, instance.dejMohutnost());


        instance.zpristupniKoren();
        assertEquals(1, instance.dejPotomka(1).a);

        instance.vlozPotomka(t2);
        assertEquals(2, instance.dejPotomka(2).a);
        instance.vlozPotomka(t3);
        assertEquals(3, instance.dejPotomka(3).a);
        assertEquals(1, instance.dejPotomka(1).a);
        assertEquals(2, instance.dejPotomka(2).a);
        assertEquals(3, instance.dejPotomka(3).a);
        assertEquals(9, instance.dejMohutnost());

        instance.zpristupniPotomka(2);
        instance.vlozPotomka(t2);
        assertEquals(t2, instance.dejPotomka(1));
        instance.vlozPotomka(t1);
        assertEquals(t1, instance.dejPotomka(2));
        instance.vlozPotomka(t3);
        assertEquals(t3, instance.dejPotomka(3));
        assertEquals(t1, instance.dejPotomka(2));
        assertEquals(t2, instance.dejPotomka(1));
        assertEquals(t3, instance.dejPotomka(3));
        assertEquals(12, instance.dejMohutnost());

        instance.zpristupniPotomka(2);
        instance.vlozPotomka(t2);
        assertEquals(t2, instance.dejPotomka(1));
        instance.vlozPotomka(t1);
        assertEquals(t1, instance.dejPotomka(2));
        instance.vlozPotomka(t3);
        assertEquals(t3, instance.dejPotomka(3));
        assertEquals(t1, instance.dejPotomka(2));
        assertEquals(t2, instance.dejPotomka(1));
        assertEquals(t3, instance.dejPotomka(3));

        assertEquals(15, instance.dejMohutnost());

    }

    /**
     * Test of testProhlidka
     */
    @Test
    public void testProhlidkaH0() {
        System.out.println("Test Prohlidka H0");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);

        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH1() {
        System.out.println("Test Prohlidka H1");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH2() {
        System.out.println("Test Prohlidka H2");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH3() {
        System.out.println("Test Prohlidka H3");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH4() {
        System.out.println("Test Prohlidka H4");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH5() {
        System.out.println("Test Prohlidka H5");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH6() {
        System.out.println("Test Prohlidka H6");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        instance.vlozPotomka(new TestClass(112, 's'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(112, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH7() {
        System.out.println("Test Prohlidka H7");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        instance.vlozPotomka(new TestClass(112, 's'));
        instance.zpristupniKoren();
        instance.zpristupniPotomka(3);
        instance.vlozPotomka(new TestClass(131, 'w'));
        instance.vlozPotomka(new TestClass(132, 'o'));
        instance.vlozPotomka(new TestClass(133, 'p'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(112, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(131, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(132, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(133, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaH8() {
        System.out.println("Test Prohlidka H8");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        instance.vlozPotomka(new TestClass(112, 's'));
        instance.zpristupniKoren();
        instance.zpristupniPotomka(3);
        instance.vlozPotomka(new TestClass(131, 'w'));
        instance.vlozPotomka(new TestClass(132, 'o'));
        instance.vlozPotomka(new TestClass(133, 'p'));
        instance.zpristupniKoren();
        instance.zpristupniPotomka(3);
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(1311, 'b'));
        iterator = instance.dejIterator(TypProhlidky.DO_HLOUBKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(112, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(131, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1311, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(132, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(133, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS0() {
        System.out.println("Test Prohlidka S0");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator = instance.dejIterator(TypProhlidky.DO_SIRKY); // T: oprava chybky v testu :)

        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS1() {
        System.out.println("Test Prohlidka S1");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS2() {
        System.out.println("Test Prohlidka S2");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS3() {
        System.out.println("Test Prohlidka S3");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS4() {
        System.out.println("Test Prohlidka S4");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS5() {
        System.out.println("Test Prohlidka S5");
        AbstrTreeImpl instance = new AbstrTreeImpl();
        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS6() {
        System.out.println("Test Prohlidka S6");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        instance.vlozPotomka(new TestClass(112, 's'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(112, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS7() {
        System.out.println("Test Prohlidka S7");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        instance.vlozPotomka(new TestClass(112, 's'));
        instance.zpristupniKoren();
        instance.zpristupniPotomka(3);
        instance.vlozPotomka(new TestClass(131, 'w'));
        instance.vlozPotomka(new TestClass(132, 'o'));
        instance.vlozPotomka(new TestClass(133, 'p'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(112, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(131, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(132, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(133, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }

    @Test
    public void testProhlidkaS8() {
        System.out.println("Test Prohlidka S8");
        AbstrTreeImpl instance = new AbstrTreeImpl();

        IIterator<TestClass> iterator;

        instance.vlozKoren(new TestClass(1, 'c'));
        instance.vlozPotomka(new TestClass(11, 'x'));
        instance.vlozPotomka(new TestClass(12, 'f'));
        instance.vlozPotomka(new TestClass(13, 't'));
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(111, 'a'));
        instance.vlozPotomka(new TestClass(112, 's'));
        instance.zpristupniKoren();
        instance.zpristupniPotomka(3);
        instance.vlozPotomka(new TestClass(131, 'w'));
        instance.vlozPotomka(new TestClass(132, 'o'));
        instance.vlozPotomka(new TestClass(133, 'p'));
        instance.zpristupniKoren();
        instance.zpristupniPotomka(3);
        instance.zpristupniPotomka(1);
        instance.vlozPotomka(new TestClass(1311, 'b'));
        iterator = instance.dejIterator(TypProhlidky.DO_SIRKY);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(11, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(12, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(13, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(111, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(112, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(131, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(132, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(133, iterator.dalsi().a);
        assertEquals(true, iterator.jeDalsi());
        assertEquals(1311, iterator.dalsi().a);
        assertEquals(false, iterator.jeDalsi());
    }
}
